export type DuplexStream = import('./types').DuplexStream<Uint8Array>;
export type AbortOptions = import('./types').AbortOptions;
import { PROTOCOL_ID } from "./constants";
export class Dialer extends MultistreamSelect {
    /**
     * @param {string | string[]} protocols
     * @param {object} [options]
     * @param {AbortSignal} options.signal
     */
    select(protocols: string | string[], options?: {
        signal: AbortSignal;
    } | undefined): Promise<{
        stream: any;
        protocol: string;
    }>;
    /**
     * @param {object} [options]
     * @param {AbortSignal} options.signal
     */
    ls(options?: {
        signal: AbortSignal;
    } | undefined): Promise<string[]>;
}
export class Listener extends MultistreamSelect {
    /**
     * @param {string | string[]} protocols
     * @param {AbortOptions} [options]
     */
    handle(protocols: string | string[], options?: import("./types").AbortOptions | undefined): Promise<{
        stream: any;
        protocol: string;
    }>;
}
/**
 * @typedef {import('./types').DuplexStream<Uint8Array>} DuplexStream
 * @typedef {import('./types').AbortOptions} AbortOptions
 */
declare class MultistreamSelect {
    /**
     * @param {DuplexStream} stream
     */
    constructor(stream: import("./types").DuplexStream<Uint8Array>);
    _stream: import("./types").DuplexStream<Uint8Array>;
    _shaken: boolean;
    /**
     * Perform the multistream-select handshake
     *
     * @param {object} [options]
     * @param {AbortSignal} options.signal
     */
    _handshake(options?: {
        signal: AbortSignal;
    } | undefined): Promise<void>;
}
export { PROTOCOL_ID };
//# sourceMappingURL=index.d.ts.map